
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>探索Java同步机制 / iVAN</title>

    <meta name="description" content="探索Java同步机制 本文将从两个方面进行阐述: 使用 C++ 语言来描述 Monitor Object 设计模式.Java 对于这样一个典型的 模式做了很好的语言层面的封装,因此对于 Java 的开发者来说,很多关于该模 式本身的东西被屏蔽掉了.本文试图使用 Native C++ 语言,帮助读者从本质上 对 Monitor object 设计模式有一个更全面的认识. 结合 C++ 版本的 Monitor Object 设计模式,引领读者对于 Java 同步机制 有一个更深刻的认识,帮助读者正确有效地使用 Java">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">探索Java同步机制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文将从两个方面进行阐述:</p>
<p>使用 C++ 语言来描述 Monitor Object 设计模式。Java 对于这样一个典型的 模式做了很好的语言层面的封装，因此对于 Java 的开发者来说，很多关于该模 式本身的东西被屏蔽掉了。本文试图使用 Native C++ 语言，帮助读者从本质上 对 Monitor object 设计模式有一个更全面的认识。</p>
<p>结合 C++ 版本的 Monitor Object 设计模式，引领读者对于 Java 同步机制 有一个更深刻的认识，帮助读者正确有效地使用 Java 同步机制。</p>
<p>预备知识</p>
<p>在开始正式讨论之前，需要了解一些预备知识。</p>
<p>什么是 RAII</p>
<p>资源获取即初始化（RAII, Resource Acquisition Is Initialization）是指 ，在一个对象的构造函数中获得资源 , 并且在该对象的析构函数中释放它。这个 资源可以是对象、内存、文件句柄或者其它类型。实现这种功能的类，我们就说 它采用了资源获取即初始化（RAII）的方式。 RAII 是一种很典型的语言惯用法 ，被很多的 OO 语言所使用，下面是 C++ 的例子。</p>
<p>清单 1. RAII Using C++</p>
<p><code>class Raii {<br />
public:<br />
　　 // Store a pointer to the resource and initialize the resource.<br />
　　 Raii(Resource &amp;resource)<br />
　　 :m_pRes (&amp;resource){<br />
　　　　 m_pRes-&gt;initialize ();<br />
　　 }<br />
　　 // Close the resource when the execution goes out of scope.<br />
　　 virtual ~Raii() {<br />
　　　　 m_pRes-&gt;close ();<br />
　　 }<br />
private:<br />
　　 // Pointer to the resource we're managing.<br />
　　 Resource *m_pRes;<br />
　　 // ... maybe need disallow copying and assignment ...<br />
};</code></p>
<p>使用 RAII 的好处是：由于析构函数由系统自动调用，这样可以帮助我们自动 地隐式释放我们所获取的资源。事情上，我们熟知的很多 c++ 技术都用到了这一 设计模式，比如：智能指针 (Smart Pointer)，以及我们接下来要讨论的范围锁 (Scoped Lock) 。</p>
<p>不同于 C++，Java 对象没有析构函数，Java System 提供了 GC 来管理内存 资源。而对于像数据库连接，Sockets 这样类型的资源， Java 提供了 finalize() 来处理。但是，请注意，Java 的 finalizer 与 C++ 的析构函数是 不同的，finalize() 函数由 GC 异步地在某个恰当的时候调用，我们不能等同地 使用 finalize() 来实现 C++ 里的 RAII 。通常的做法是使用 Java 提供的 finally 语句块。</p>
<p>清单 2. RAII Using Java</p>
<p><code>MyResource res = null;<br />
try {<br />
　　 res = new MyResource();<br />
　　 // Use the resource<br />
} finally {<br />
　　 //At exit point, close the resource.<br />
　　 if (res != null) { res.close(); }<br />
}</code></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 00:17:56</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e8%b5%84%e6%ba%90/" title="资源">资源</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e8%ae%be%e8%ae%a1%e6%a8%a1%e5%bc%8f/" title="设计模式">设计模式</a>, <a href="https://www.iamivan.net/tag/resource/" title="resource">resource</a>, <a href="https://www.iamivan.net/tag/ettle%e6%8e%a2%e7%b4%a2%e8%b5%84%e6%ba%90%e5%ba%93%e6%8a%a5%e9%94%99/" title="ettle探索资源库报错">ettle探索资源库报错</a>, <a href="https://www.iamivan.net/tag/raii%e6%9c%ba%e5%88%b6/" title="RAII机制">RAII机制</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>探索Java同步机制的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpkaE5b.html" rel="bookmark">Java同步机制浅谈&horbar;&horbar;synchronized对代码作何影响？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java对多线程的支持与同步机制深受大家的喜爱,似乎看起来使用了synchronized关键字就可以轻松地解决多线程共享数据同步问题.到底如何?――还得对synchronized关键字的作用进行深入了解才可定论.总的说来,synchronized关键字可以作为函数的修饰符,也可作为函数内的语句,也就是平时说的同步方法和同步语句块.如果再细的分类,synchronized可作用于instance变量.object reference(对象引用).static函数和class literals(类名			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1RvP5p.html" rel="bookmark">Java同步机制：sychronized对代码影响</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java对多线程的支持与同步机制深受大家的喜爱,似乎看起来使用了synchronized关键字就可以轻松地解决多线程共享数据同步问题.到底如何?――还得对synchronized关键字的作用进行深入了解才可定论. 总的说来,synchronized关键字可以作为函数的修饰符,也可作为函数内的语句,也就是平时说的同步方法和同步语句块.如果再细的分类,synchronized可作用于instance变量.object reference(对象引用).static函数和class literals(类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL7Je5M.html" rel="bookmark">java 同步机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在使用synchronized同步的时候,线程被阻塞,进入等待状态,在等待的时候线程会自己停止吗?若会,那么相关的信息不就丢失了吗? 解决方案 不会停止,线程是在等待唤醒,当被锁的对像释放锁以后,等待的线程就会被唤醒,当然相关的信息也不会丢失的.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boraXz.html" rel="bookmark">Java线程机制&lpar;四&rpar; 同步方法和同步块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在之前例子的基础上,我们增加新的功能:根据正确与不正确的响应来显示玩家的分数. public class ScoreLabel extends JLabel implements CharacterListener { private volatile int score = 0; private int char2type = -1; private CharacterSource generator = null, typist = null; public ScoreLabel(Chara			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pke5aEb.html" rel="bookmark">JAVA多线程机制之同步与互斥</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个多线程的程序,两个或者多个线程可能需要访问同一个数据资源.这时就必须考虑数据安全的问题,需要线程互斥或者同步. 线程的互斥 当多个线程需要访问同一资源时,要求在一个时间段内只能允许一个线程来操作共享资源,操作完毕后别的线程才能读取该资源,这叫线程的互斥.我们需要使用synchronized来给共享区域加锁,确保共享资源安全. 如果一个线程调用了某个对象的synchronized方法,它在这个方法运行完之前不会被别的线程打断,这就是线程的同步机制.一般将共享资源放在这个同步方法内部,这样就保证			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK5EJAp.html" rel="bookmark">《深入解析Android 5&period;0系统》&mdash;&mdash;第6章，第6&period;3节Android Java层的同步机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6.3 Android Java层的同步机制 深入解析Android 5.0系统 Java语言和C/C++语言不一样,Java语言中提供了同步关键字synchronized来支持线程间的同步操作. 6.3.1 同步关键字synchronized synchronized关键字最常见的用法是保护一段代码,如下所示: class Foo implements Runnable { private String mLock; public void lockedMethod() { ...... sy			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyNPkp.html" rel="bookmark">Java线程机制&lpar;五&rpar; 等待与通知机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在之前我们关于停止Thread的讨论中,曾经使用过设定标记done的做法,一旦done设置为true,线程就会 结束,一旦为false,线程就会永远运行下去.这样做法会消耗掉许多CPU循环,是一种对内存不友好的行为. java中的对象不仅拥有锁,而且它们本身就可以通过调用相关方法使自己成为等待者和通知者. Object对象本身有两个方法:wait()和notify().wait()会等待条件的发生,而notify()会通知正在 等待的线程此条件已经发生,它们都必须从synchronized方法或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeBKwb.html" rel="bookmark">Java线程机制&lpar;三&rpar; synchronized和volatile的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在开始进入线程编程中最重要的话题---数据同步,它是线程编程的核心,也是难点,就算我们理解了 数据同步的基本原理,但是我们也无法保证能够写出正确的同步代码,但基本原理是必须掌握的. 要 想理解数据同步的基本原理,首先就要明白,为什么我们要数据同步? public class CharacterDisplayCanvas extends JComponent implements CharacterListener { protected FontMetrics fm; protected ch			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7YBKz.html" rel="bookmark">多线程-synchronized java &OpenCurlyDoubleQuote;同步&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 synchronized java &quot;同步&quot; 在Java中,synchronized关键字是用来控制线程同步的,就是在多线程的环境下,控制synchronized代码段不被多个线程同时执行.synchronized既可以加在一段代码上,也可以加在方法上. 知道synchronized是干什么的了,但还是不理解&quot;同步&quot;二字表示什么意思?与其作用关联不到一起: synchronized是用来控制线程不能同步的,多个线程不能同时执行某段代码的步骤,应该是这样理解			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeLxAp.html" rel="bookmark" class="title">find 按文件修改时间查找文件及find空文件夹</a>
					<div>
						  查找两天前修改过的文件: find . -type f -mtime -2 查找3天内修改过的文件: find -ctime -3 find命令使用超过6天,空文件独立查询命令: find /da ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLdLRp.html" rel="bookmark" class="title">搭配的艺术--谈主页用色</a>
					<div>
						要想做出一幅漂亮的主页可不是一件容易的事,除了熟练运用各种网页制作工具和编程语言之外,美术的知识也不能不懂,下面让我们来学习一点有关主页制作中色彩搭配的知识. 色彩的含义 色彩本身是无任何含义的,有的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw9WnM.html" rel="bookmark" class="title">ASP基础学习：access&plus;asp 练习一</a>
					<div>
						access 练习一:建立一简单数据库的添加.显示.查询功能实现 注:[采用access2000+asp,数据库:customer.mdb(字段: 公司名(字符型).电话(数据型).传真(数据型).类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnyOKM.html" rel="bookmark" class="title">jsp读取大对象CLOB并生成xml文件示例</a>
					<div>
						js|xml|对象|生成xml|示例 &lt;%@ page contentType=&quot;text/html; charset=gb2312&quot; %&gt;&lt;%@ page in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9ze5nVz.html" rel="bookmark" class="title">初学者入门：细述PHP4的核心Zend</a>
					<div>
						一.概述: Zend引擎的名称由Zeev Suraski和Andi Gutmans二位在PHP担任核心开发工作的资深设计师的名字合体.开发的目的师为了研发新的脚本执行机制,而PHP4就是这套崭新的Ze ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boQQEp.html" rel="bookmark" class="title">浏览器chrome添加搜索栏 增强右键搜索菜单插件</a>
					<div>
						  我们每天都需要获取大量的信息,而绝大多数的获取方式都是通过搜索引擎,所以浏览器能否实现快速高效的搜索就显得比较重要了,现在的浏览器大多数都自带了快捷搜索框,却没有办法实现划词搜索.自定义搜索引擎这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv0JNz.html" rel="bookmark" class="title">浅谈网站日常维护工作哪些是关键</a>
					<div>
						对于网站维护者而言平时需做哪些事,相信广大的站长朋友们都十分的清楚,但哪些工作才是日常网站维护工作当中最为关键的呢?下面A5站长网SEO诊断优化团队就来和广大的站长朋友们浅谈下究竟网站日常维护工作哪些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeQj8z.html" rel="bookmark" class="title">IPv6 PMTUD路径发现机制和工作原理</a>
					<div>
						PMTUD是IPv6的一个工作机制. 其主要的目的就是,当网络源发送数据报文到目的的时候,避免分段,也可以称为分片. 源节点可以使用发现整个路径上面最大的MTU与目的节点通讯. 我们都知道,分段实际上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NkBmz.html" rel="bookmark" class="title">Android ApiDemos示例解析&lpar;3&rpar; App-&amp;amp&semi;gt&semi;Activity-&amp;amp&semi;gt&semi;Animation</a>
					<div>
						App-&gt;Activity-&gt;Animation 示例用于演示不同Activity切换时动态效果.例子中定义了两种动画效果,渐变Fade In, 新出现的Activity由浅入深逐渐显示, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Ra2xp.html" rel="bookmark" class="title">JAVA对大数值的计算</a>
					<div>
						相信大家都可能碰到要对超过17位整数的值进行计算,Java中对double的值超过8位就会变成科学计数法,所以我用了DecimalFormat进行格式化,当pattern为&quot;######## ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7DL3b.html" rel="bookmark" class="title">orale数据库如何利用sql语句创建视图的一般性使用方法</a>
					<div>
						SQL CREATE VIEW 语句 什么是视图? 在 SQL 中,视图是基于 SQL 语句的结果集的可视化的表. 视图包含行和列,就像一个真实的表.视图中的字段就是来自一个或多个数据库教程中的真实的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaA9QM.html" rel="bookmark" class="title">WinPE盘符修改大法</a>
					<div>
						  第一步:打开WINPE.INI文件,在里面修改: //配置文件开始 MOUN %CurDrv%MINIPEOP.WIM,W:,1 ENVI OPDir=W:外置程序 第二步:把WinPE.IS_内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGY2op.html" rel="bookmark" class="title">&lpar;cljs&sol;run-at &lpar;-&amp;gt&semi;JSVM &colon;browser&rpar; &amp;quot&semi;语言基础&amp;quot&semi;&rpar;</a>
					<div>
						前言  两年多前知道cljs的存在时十分兴奋,但因为工作中根本用不上,国内也没有专门的职位于是搁置了对其的探索.而近一两年来又刮起了函数式编程的风潮,恰逢有幸主理新项目的前端架构,于是引入Ramda. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZW8ob.html" rel="bookmark" class="title">zend framework多模块多布局配置&lowbar;php技巧</a>
					<div>
						许多人在使用过程中都会遇到这样那样的问题,而且zend framework现在已经到1.11版本了,网络上的很多资料都还停留在旧版本上,因此我在这里以当前的最新版本1.11为例,来简单介绍一下如何使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWQDXp.html" rel="bookmark" class="title">使用RestTemplate上传文件</a>
					<div>
						最近在用Spring Cloud,搭建微服务应用,其中一个微服务是把文件上传到七牛,其他的文件上传都是通过他.但是在使用Fegin调用该服务的接口的时候,一直有问题,恩--------先用RestTe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NgGnz.html" rel="bookmark" class="title">优质论文list（分布式系统&sol;存储&sol;索引相关）</a>
					<div>
						 转载请注明出处:http://blog.csdn.net/zbf8441372 5. CoHadoop: Flexible Data Placement and Its Exploitation i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmQoRz.html" rel="bookmark" class="title">socket-networkstream数据流的写入</a>
					<div>
						问题描述 networkstream数据流的写入 networkstream.write(byte[] aaa,0,aaa.lenth); 如何判断写入完毕,以及怎么获得写入花费的时间 解决方案 这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NXBmz.html" rel="bookmark" class="title">输出-单词排序，输入一句话，按照单词的顺序排列</a>
					<div>
						问题描述 单词排序,输入一句话,按照单词的顺序排列 单词排序,输入一句话,按照单词的顺序排列,比如输入:Hello, Welecome to Henan Univercity,输出Hello Hena ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6v9jz.html" rel="bookmark" class="title">虚心求教！Extjs vtype 无法正确返回值</a>
					<div>
						问题描述 Ext.apply(Ext.form.field.VTypes,{cityNameExist:function(value,field){var exist = false;Ext.Ajax ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd89Zb.html" rel="bookmark" class="title">大疆农业飞防赛：除了关注技术本身，无人机更需要跟行业相结合</a>
					<div>
						&quot;星河·领创天下&quot;创客空间位于深圳龙岗区坂田的一个半山腰上,山顶有一块10000平米的专用飞场,是飞无人机的绝佳场所.去年8月底,慧飞无人机应用技术培训中心的第一期学员就是在这块场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjL5rM.html" rel="bookmark" class="title">量化项目管理案例：缺陷趋势预测利器（1）</a>
					<div>
						量化项目管理案例:缺陷趋势预测利器(1) 不知身为软件工程师的你,在写代码时是不是有过这样的经历:一方面对自己写的代码信心满满,一方面又非常希望知道自己开发的代码的质量到底多高.如果代码真的没被测出b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeor1AM.html" rel="bookmark" class="title">springmvc-sprinmvc 怎么进行单元测试？</a>
					<div>
						问题描述 sprinmvc 怎么进行单元测试? 项目springmvc + mybatis,用maven搭的框架,现在要对controller层进行单元测试, 请问怎么测,给下思路?其他方法都是用ju ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nLNDz.html" rel="bookmark" class="title">用jquery 改写下面代码，昨天刚学，改过了就没用了</a>
					<div>
						问题描述 用jquery 改写下面代码,昨天刚学,改过了就没用了 这是我之前写的.老师要求用jquery改进,刚接触jquery,不大会啊 &lt;!DOCTYPE html PUBLIC &quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJ3Znp.html" rel="bookmark" class="title">有人现在做Infor的产品么？</a>
					<div>
						问题描述 RT:有人现在做Infor的产品不?感觉怎么样? 解决方案 解决方案二:我们公司用的VISUAL7					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44yg9z.html" rel="bookmark" class="title">苏宁近千亿真相</a>
					<div>
						摘要: 久旱逢甘霖.必有蹊跷? 苏宁云商(002024.SZ)在近期宣布拟开展银行业务因素的影响下,9月24日收盘涨至近期高点13.21元,市值达975亿元.此后两日,其股价有所调整,26日收报于11 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKq7QM.html" rel="bookmark" class="title">PHP移除指定HTML标签方法总结</a>
					<div>
						有时候我们需要把html标签页存到数据库里,但是有些场合却需要拿无html标签的纯数据,这个时候就要对带html标签的数据进行处理,把html标签都去掉.平时用 htmlspecialchars()  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWV9Gz.html" rel="bookmark" class="title">form身份验证通过后，只能用FormsAuthentication&period;RedirectFromLoginPage&lowbar;实用技巧</a>
					<div>
						直接用Response.Redirect(&quot;default.aspx&quot;)的话当然验证失败,因为你根本没有建立身份验证票.FormsAuthentication.RedirectFr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKg0jM.html" rel="bookmark" class="title">PHP截取指定图片大小的方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了PHP截取指定图片大小的方法.分享给大家供大家参考.具体分析如下: imagecopyresampled($newim, $im, 0, 0, 7, 174, 120, 42, $new ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0Gnxp.html" rel="bookmark" class="title">怎么样编写一个程序，彻底可以从系统中隐藏调用</a>
					<div>
						问题描述 怎么样编写一个程序,彻底可以从系统中隐藏调用 怎么样编写一个程序,彻底可以从系统中隐藏调用,包括文件名和进程都不被看到,但是可以执行其中的程序呢? 解决方案 http://blog.csdn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba69KqM.html" rel="bookmark" class="title">为您解密验证码技术如何区分人和电脑</a>
					<div>
						你知道什么是验证码吗? &quot;验证码&quot;( CAPTCHA )并不是各位网友一直会在不同网站上看到的那些难以辨认的字母组合的代名词,验证码的俗称是&quot;全自动区分计算机和人类的图灵 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
